use std::sync::Arc;

use axum::{Extension, Json};
use foxchat::{
    http::ApiError,
    s2s::http::{HelloRequest, HelloResponse, NodeResponse}, fed,
};

use crate::{app_state::AppState, model::instance::Instance};

pub async fn post_hello(
    Extension(state): Extension<Arc<AppState>>,
    Json(data): Json<HelloRequest>,
) -> Result<Json<HelloResponse>, ApiError> {
    let instance = Instance::get(&state.pool).await?;

    let node = fed::get::<NodeResponse>(&instance.private_key, &state.config.domain, &data.host, "/_fox/ident/node", None).await?;

    // TODO: validate identity server's signature, probably adapt FoxRequestData.from_request_parts() (or extract it into a separate function? not sure if that's possible though)
    todo!()
}
